import Control.Monad (liftM, liftM2, (<=<))

{-
  Mini Course: Functional Programming
  Jeremie Gillet

  Day 2 - Pattern Matching
-}

isOne :: Int -> Bool
isOne = undefined

swap :: (a, b) -> (b, a)
swap = undefined

first :: (a, b, c) -> a
first = undefined

second :: (a, b, c) -> b
second = undefined

third :: (a, b, c) -> c
third = undefined

empty :: [a] -> Bool
empty = undefined

startsWithX :: String -> Bool
startsWithX = undefined

startsWith :: Char -> String -> Bool
startsWith = undefined

true :: a -> Bool
true = undefined

firstFirst :: [(a, b)] -> a
firstFirst = undefined

{-
  Day 2 - Recursion
-}

length' :: [a] -> Int
length' = length

head' :: [a] -> a
head' = head

last' :: [a] -> a
last' = last

elem' :: (Eq a) => a -> [a] -> Bool
elem' = elem

find :: (a -> Bool) -> [a] -> a
find = undefined

sum' :: Num a => [a] -> a
sum' = sum

maximum' :: Ord a => [a] -> a
maximum' = maximum

replicate' :: Int -> a -> [a]
replicate' = replicate

take' :: Int -> [a] -> [a]
take' = take

all' :: (a -> Bool) -> [a] -> Bool
all' = all

any' :: (a -> Bool) -> [a] -> Bool
any' = any

map' :: (a -> b) -> [a] -> [b]
map' = map

filter' :: (a -> Bool) -> [a] -> [a]
filter' = filter

zip' :: [a] -> [b] -> [(a, b)]
zip' = zip

reverse' :: [a] -> [a]
reverse' = reverse

{-
  Day 2 - Folds
-}

length'' :: [a] -> Int
length'' = length

head'' :: [a] -> a
head'' = head

last'' :: [a] -> a
last'' = last

elem'' :: (Eq a) => a -> [a] -> Bool
elem'' = elem

sum'' :: Num a => [a] -> a
sum'' = sum

maximum'' :: Ord a => [a] -> a
maximum'' = maximum

all'' :: (a -> Bool) -> [a] -> Bool
all'' = all

any'' :: (a -> Bool) -> [a] -> Bool
any'' = any

map'' :: (a -> b) -> [a] -> [b]
map'' = map

filter'' :: (a -> Bool) -> [a] -> [a]
filter'' = filter

reverse'' :: [a] -> [a]
reverse'' = reverse

{-
    Day 2 - Maybe
-}

safeTail :: [a] -> Maybe a
safeTail = undefined

-- Using safeTail, show the tail is it exists, otherwise show "There is no tail"
isThereATail :: [Int] -> String
isThereATail = undefined

-- Output a list with three times the tail of there is one. Use pattern matching
threeTimeTheTail :: [a] -> Maybe [a]
threeTimeTheTail = undefined

--Same but use liftM
threeTimeTheTail' :: [a] -> Maybe [a]
threeTimeTheTail' = undefined
