{-

    Algebraic Data Structures Exercises

-}

-- Implement Binary Tree data type and some functions on it
data Tree a = ...


root :: Tree a -> Maybe a
root t = undefined


leftChild :: Tree a -> Maybe (Tree a)
leftChild t = undefined


rightChild :: Tree a -> Maybe (Tree a)
rightChild t = undefined


-- Compute the number of nodes in a tree
size :: Tree a -> Int
size = undefined


-- All elements of each left subtree should be smaller than a root value and
-- All elements of each right subtree should be bigger than a root value
addElem :: Ord a => Tree a -> a -> Tree a
addElem t a = undefined


-- Turn a list into a tree
packList :: Ord a => [a] -> Tree a
packList xs = undefined


-- Identify either element is in the tree or not
findElem :: (Ord a, Eq a) => Tree a -> a -> Bool
findElem t a = undefined


-- map, but for trees
tmap :: (a -> b) -> Tree a -> Tree b
tmap f t = undefined


{-

    Monad Exercises

-}

-- Define some monadic functions


-- Base function
replicate' :: Int -> a -> [a]
replicate' 0 _ = []
replicate' n a = a : replicate' (n-1) a

-- Monadic function
replicateM' :: Monad m => Int -> m a -> m [a]
replicateM' = undefined


-- Base function
zipWith' :: (a -> b -> c) -> [a] -> [b] -> [c]
zipWith' _ [] _ = []
zipWith' _ _ [] = []
zipWith' f (x:xs) (y:ys) = (f x y) : (zipWith' f xs ys)

-- Monadic function
zipWithM' :: Monad m => (a -> b -> m c) -> [a] -> [b] -> m [c]
zipWithM' = undefined


-- Base function
filter' :: (a -> Bool) -> [a] -> [a]
filter' _ [] = []
filter' f (x:xs) = if f x
                   then x : filter' f xs
                   else filter' f xs


-- Monadic function
filterM' :: Monad m => (a -> m Bool) -> [a] -> m [a]
filterM' = undefined

